
CREATE DATABASE Acqua_gas;
USE Acqua_gas;

CREATE TABLE Erogatore
(
 Partita_IVA CHAR(11) NOT NULL,
 Ragione_sociale VARCHAR(128) NOT NULL,
 PRIMARY KEY (Partita_IVA)
);

CREATE TABLE Cliente
(
 Codice_fiscale CHAR(16) NOT NULL,
 Cognome VARCHAR(32) NOT NULL,
 Nome VARCHAR(32) NOT NULL,
 Indirizzo VARCHAR(128) NOT NULL,
 Numero VARCHAR(8) NOT NULL,
 Località VARCHAR(32) NOT NULL,
 CAP CHAR(5) NOT NULL,
 Comune VARCHAR(32) NOT NULL,
 Provincia CHAR(2) NOT NULL,
 PRIMARY KEY (Codice_fiscale)
);


CREATE TABLE Contatore
(
 ID_contatore CHAR(16) NOT NULL,
 Tipo CHAR(1) NOT NULL,
 Erogatore CHAR(11) NOT NULL,
 Latitudine FLOAT,
 Longitudine FLOAT,
 Cliente CHAR(16) NOT NULL,
 PRIMARY KEY (ID_contatore),
 FOREIGN KEY (Erogatore) REFERENCES Erogatore(Partita_IVA),
 FOREIGN KEY (Cliente) REFERENCES Cliente(Codice_fiscale)
);

CREATE TABLE Autolettura (
 ID_autolettura INTEGER NOT NULL AUTO_INCREMENT,
 Contatore CHAR(16) NOT NULL,
 Data_ora TIMESTAMP NOT NULL,
 Consumo REAL NOT NULL,
 Valida BOOLEAN NOT NULL DEFAULT FALSE,
 PRIMARY KEY (ID_autolettura)
);

CREATE TABLE Dispositivo
(
 API_key CHAR(32) NOT NULL,
 Modello_hardware VARCHAR(32) NOT NULL,
 Sistema_operativo VARCHAR(32) NOT NULL,
 Versione_APP VARCHAR(4) NOT NULL,
 PRIMARY KEY (API_key)
);

CREATE TABLE Lettura (
 ID_lettura INTEGER NOT NULL AUTO_INCREMENT,
 Contatore CHAR(16) NOT NULL,
 Data_ora TIMESTAMP NOT NULL,
 Consumo REAL NOT NULL,
 Dispositivo CHAR(32) NOT NULL,
 PRIMARY KEY (ID_lettura),
 FOREIGN KEY (Dispositivo) REFERENCES Dispositivo(API_key)
);
