
package it.acquagas.rete.APISERV;

import java.io.*;
import java.sql.*;
import javax.ws.rs.core.*;
import javax.ws.rs.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;

@ApplicationPath("/")
@Path("")
public class APISERV extends Application {
    final private static String driver = "com.mysql.jdbc.Driver";
    final private static String dbms_url = "jdbc:mysql://127.0.0.1:3306/";
    final private static String database = "acqua_gas";
    final private static String user = "root";
    final private static String password = "";
    private static Connection connection;

    public APISERV() {
        super();
        if (connection == null) {
            String url = dbms_url+database;
            try {
                Class.forName(driver);
                connection = DriverManager.getConnection(url, user, password);
            }
            catch (SQLException e) {
            }
            catch (ClassNotFoundException e) {
            }
        }
    }

    @GET
    @Produces("text/xml")
    @Path("/consumo/{contatore}")
    public String getConsumo(@PathParam(value="contatore") String contatore,
                             @QueryParam(value="erogatore") String erogatore) {
        Statement statement;
        ResultSet letture, autoletture;
        float lettura = 0, autolettura = 0;
        String tipo_lettura = "", tipo_autolettura = "";
        String answer = "";
        
        if (connection == null)
            throw new WebApplicationException(500);
        try {
            statement = connection.createStatement();
        }
        catch (SQLException e) {
            throw new WebApplicationException(500); // INTERNAL SERVER ERROR
        }
        try {
            String query = "SELECT Lettura.Consumo, Contatore.Tipo FROM Lettura, Contatore WHERE Lettura.Contatore = Contatore.ID_contatore AND Lettura.Contatore = '" + contatore + "' AND Contatore.Erogatore = '" + erogatore + "' ORDER BY Lettura.Data_ora DESC;";
            letture = statement.executeQuery(query);
            if (letture.next()) {
                lettura = letture.getFloat(1);
                tipo_lettura = letture.getString(2);
            }
            else
                lettura = 0;
            letture.close();
        }
        catch (SQLException e) {
            lettura = 0;
        }
        try {
            String query = "SELECT Autolettura.Consumo, Contatore.Tipo FROM Autolettura, Contatore WHERE Autolettura.Contatore = Contatore.ID_contatore AND Autolettura.Contatore = '" + contatore + "' AND Contatore.Erogatore = '" + erogatore + "' AND Autolettura.Valida = TRUE ORDER BY Autolettura.Data_ora DESC;";
            autoletture = statement.executeQuery(query);
            if (autoletture.next()) {
                autolettura = autoletture.getFloat(1);
                tipo_autolettura = autoletture.getString(2);
            }
            else
                autolettura = 0;
            autoletture.close();
        }
        catch (SQLException e) {
            autolettura = 0;
        }
        try {
            statement.close();
        }
        catch (SQLException e) {
        }
        if (lettura == 0 && autolettura == 0)
            throw new WebApplicationException(404); // NOT FOUND
        // scrittura del body della risposta
        if (lettura > autolettura)
            answer += "<consumo tipo=\"" + tipo_lettura +"\">"+ lettura + "</consumo>\r\n";
        else
            answer += "<consumo tipo=\"" + tipo_autolettura +"\">"+ autolettura + "</consumo>\r\n";
        return answer; // OK
    }

    @POST
    @Consumes("application/xml")
    @Path("/autolettura/{contatore}")
    public Response addAutolettura(String content, @PathParam(value="contatore") String contatore,
                                                   @QueryParam(value="erogatore") String erogatore) {
        String tipo;
        float autolettura;
        Statement statement;
        ResultSet resultset;
                   
        if (connection == null)
            throw new WebApplicationException(500);
        try {
            statement = connection.createStatement();
        }
        catch (SQLException e) {
            throw new WebApplicationException(500); // INTERNAL SERVER ERROR
        }
        try {
            String query = "SELECT * FROM Contatore WHERE Contatore.ID_contatore = '" + contatore + "' AND Contatore.Erogatore = '" + erogatore + "';";
            resultset = statement.executeQuery(query);
            if (resultset.next()) {
            }
            else {
                resultset.close();
                statement.close();
                throw new WebApplicationException(400); // BAD REQUEST
            }
            resultset.close();
        }
        catch (SQLException e) {
            throw new WebApplicationException(400); // BAD REQUEST
        }
        try {
            // estrazione dei valori dell'attributo "tipo" e del valore dell'elemento "autolettura"
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            InputSource input = new InputSource();
            input.setCharacterStream(new StringReader(content));
            Document document = builder.parse(input);
            Element root = document.getDocumentElement();
            if (!root.getNodeName().equalsIgnoreCase("autolettura"))
                throw new WebApplicationException(400); // BAD REQUEST
            tipo = root.getAttribute("tipo");
            if (tipo.equalsIgnoreCase(""))
                throw new WebApplicationException(400); // BAD REQUEST
            String tmp = root.getFirstChild().getNodeValue();
            try {
                autolettura = Float.valueOf(tmp);
            }
            catch (NumberFormatException e) {
                throw new WebApplicationException(400); // BAD REQUEST
            }
            try {
                String command = "INSERT Autolettura(Contatore, Data_ora, Consumo) VALUES('" + contatore + "', NOW(), " + Float.toString(autolettura) + ");";
                if (statement.executeUpdate(command) <= 0) {
                    statement.close();
                    throw new WebApplicationException(500); // INTERNAL SERVER ERROR
                }
                statement.close();
            }
            catch (SQLException e) {
                throw new WebApplicationException(500); // INTERNAL SERVER ERROR
            }
        }
        catch (ParserConfigurationException e) {
            throw new WebApplicationException(500); // INTERNAL SERVER ERROR
        }
        catch (SAXException e) {
            throw new WebApplicationException(500); // INTERNAL SERVER ERROR
        }
        catch (IOException e) {
            throw new WebApplicationException(500); // INTERNAL SERVER ERROR
        }
        return Response.status(201).build(); // OK, CREATED
    }
}
